
#define attriwram __attribute__ ((section (".data.iwram")))
//#define attriwram 

#define ADR_BGCHR0  0/16 // 32kb 1024char(256x256pixel)
#define ADR_BGMAP0 60/ 2 //  2kb 256x256map
#define ADR_BGCHR1 32/16 // 28kb 896char(256x224pixel)
#define ADR_BGMAP1 62/ 2 //  2kb 256x256map
#define ADR_BGCHR2  0/16
#define ADR_BGMAP2  0/ 2
#define ADR_BGCHR3  0/16
#define ADR_BGMAP3  0/ 2

// BGAhX
u16 *BGPAL = MEM_BG_PAL;
u16 *BGCHR0 = MEM_BG_CHAR(ADR_BGCHR0);
u16 *BGMAP0 = MEM_BG_MAP(ADR_BGMAP0);
u16 *BGCHR1 = MEM_BG_CHAR(ADR_BGCHR1);
u16 *BGMAP1 = MEM_BG_MAP(ADR_BGMAP1);
u16 *BGCHR2 = MEM_BG_CHAR(ADR_BGCHR2);
u16 *BGMAP2 = MEM_BG_MAP(ADR_BGMAP2);
u16 *BGCHR3 = MEM_BG_CHAR(ADR_BGCHR3);
u16 *BGMAP3 = MEM_BG_MAP(ADR_BGMAP3);

void InitializeSprites(void); // func.0
attriwram void fp_MoveSprite(u8 no, int x, int y); // func.1
void (*MoveSprite)(u8 no, int x, int y)=fp_MoveSprite;
attriwram void fp_SetSpriteSize(u8 no,u16 size,u16 form,u16 color); // func.2
void (*SetSpriteSize)(u8 no,u16 size,u16 form,u16 color)=fp_SetSpriteSize;
attriwram void fp_SetSpritePalette(u8 no, u8 pal); // func.3
void (*SetSpritePalette)(u8 no, u8 pal)=fp_SetSpritePalette;
attriwram void fp_SetSpriteMode(u8 no,u16 mode); // func.4
void (*SetSpriteMode)(u8 no,u16 mode)=fp_SetSpriteMode;
attriwram void fp_SetSpriteRotation(u8 no,b8 enable); // func.5
void (*SetSpriteRotation)(u8 no,b8 enable)=fp_SetSpriteRotation;
attriwram void fp_ChangeSprite(u8 no, u16 ch); // func.6
void (*ChangeSprite)(u8 no, u16 ch)=fp_ChangeSprite;
attriwram void fp_SetSpritePriority(u8 no, u8 p); // func.7
void (*SetSpritePriority)(u8 no, u8 p)=fp_SetSpritePriority;
void SetBGCHR(u8 BGNo,u16 chr,u16* img,u16* pal); // func.8
void SetBG2CHR(u16 chr,u16* img,u16* pal); // func.9
void SetOAMCHR(u32 chrbase,u32 chrsize,u16* chr,u32 palbase,u32 palsize,u16* pal); // func.10
void SetBG0MAP(u16 x,u16 y,u16 palno,u16 chr); // func.11
void SetBG1MAP(u16 x,u16 y,u16 palno,u16 chr); // func.12
void SetBG2MAP(u16 x,u16 y,u16 chr); // func.13
void SetBG2MAP16(u16 x,u16 y,u16 chr); // func.14
void BG0_putpixel1(u32 x,u32 y,u16 col); // func.15
void BG0_putpixel2(u32 x,u32 y,u32 col); // func.16
void BG0_putpixel4(u32 x,u32 y,u32 col); // func.17
void BG1_putpixel4(u32 x,u32 y,u32 col); // func.18

// ׂẴXvCg\Ȃ
void InitializeSprites(void)
{
  funcadd(FuncC_main_img,0);
  
  OAMEntry* sprites = (OAMEntry*)OAMmem; // OAM
  
  int loop;
  for(loop = 0; loop < 128; loop++)
  {
    sprites[loop].attribute0 = 160;  //y to > 159
    sprites[loop].attribute1 = 240;  //x to > 239
  }
}

// XvCg̈ʒuύX
void fp_MoveSprite(u8 no, int x, int y)
{
  funcadd(FuncC_main_img,1);
  
  OAMEntry* sp = (OAMEntry*)OAMmem+no; // OAM

  if(x<0) x=512+x;
  if(y<0) y=256+y;

  sp->attribute1 = (sp->attribute1 & 0xFE00) | x;
  sp->attribute0 = (sp->attribute0 & 0xFF00) | y;
}

/* -----------------------------------------  /
  SetSpriteSize
  XvCǧ`ݒ
  spEEEύXXvCgw
  sizeEESP_SIZE_8,SP_SIZE_16,SP_SIZE_32,SP_SIZE_64̂ꂩ
  formEESP_SQUARE,SP_TALL,SP_WIDE
  colorEESP_COLOR_16,SP_COLOR_256
/ ------------------------------------------ */
void fp_SetSpriteSize(u8 no,u16 size,u16 form,u16 color)
{
  funcadd(FuncC_main_img,2);
  
  OAMEntry* sp = (OAMEntry*)OAMmem+no; // OAM
  
  sp->attribute0 &= 0x1FFF;
  sp->attribute0 |= color | form | (160);
  
  sp->attribute1 &= 0x3FFF;
  sp->attribute1 |= size | (240);
}

void fp_SetSpritePalette(u8 no, u8 pal)
{
  funcadd(FuncC_main_img,3);
  
  OAMEntry* sp = (OAMEntry*)OAMmem+no; // OAM
  
  sp->attribute2&=~(BIT15|BIT14|BIT13|BIT12);
  sp->attribute2|=pal<<12;
}

void fp_SetSpriteMode(u8 no,u16 mode)
{
  funcadd(FuncC_main_img,4);
  
  OAMEntry* sp = (OAMEntry*)OAMmem+no; // OAM
  
  // SP_MODE_NORMAL SP_MODE_TRANSPERANT SP_MODE_WINDOWED
  sp->attribute0 &= ~(BIT11|BIT10);
  sp->attribute0 |= mode;
}

void fp_SetSpriteRotation(u8 no,b8 enable)
{
  funcadd(FuncC_main_img,5);
  
  OAMEntry* sp = (OAMEntry*)OAMmem+no; // OAM
  
  sp->attribute0 &= ~(BIT9|BIT8);
  if(enable==True) sp->attribute0 |= SP_SIZE_DOUBLE|SP_ROTATION_FLAG;
}

void fp_ChangeSprite(u8 no, u16 ch)
{
  funcadd(FuncC_main_img,6);
  
  OAMEntry* sp = (OAMEntry*)OAMmem+no; // OAM
  
  sp->attribute2 = sp->attribute2 & 0xFC00;
  sp->attribute2 = sp->attribute2 | ch;
}

void fp_SetSpritePriority(u8 no, u8 p)
{
  funcadd(FuncC_main_img,7);
  
  OAMEntry* sp = (OAMEntry*)OAMmem+no; // OAM
  
  sp->attribute2&=~(BIT11|BIT10);
  sp->attribute2|=p<<10;
}

void SetBGCHR(u8 BGNo,u16 chr,u16* img,u16* pal)
{
  funcadd(FuncC_main_img,8);
  
  while((REG_DM3CNT_H&BIT15)!=0);
  REG_DM3CNT_H = (DMA_TRANSFER_OFF);
  REG_DM3SAD = (u32)&pal[0];
  if(BGNo==0){
    REG_DM3DAD = (u32)&BGPAL[128];
    }else{
    REG_DM3DAD = (u32)&BGPAL[192];
  }
  REG_DM3CNT_L=64*2/4;
  REG_DM3CNT_H=(DMA_SIZE_32 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
                DMA_REPEAT_OFF | DMA_SAD_INC | DMA_DAD_INC | DMA_INTR_ON);

  while((REG_DM3CNT_H&BIT15)!=0);
  REG_DM3CNT_H = (DMA_TRANSFER_OFF);
  REG_DM3SAD = (u32)&img[0];
  if(BGNo==0){
    REG_DM3DAD = (u32)BGCHR0;
    }else{
    REG_DM3DAD = (u32)BGCHR1;
  }
  REG_DM3CNT_L=chr*32/4;
  REG_DM3CNT_H=(DMA_SIZE_32 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
                DMA_REPEAT_OFF | DMA_SAD_INC | DMA_DAD_INC | DMA_INTR_ON);
}

void SetBG2CHR(u16 chr,u16* img,u16* pal)
{
  funcadd(FuncC_main_img,9);
  
  while((REG_DM3CNT_H&BIT15)!=0);
  REG_DM3CNT_H = (DMA_TRANSFER_OFF);
  REG_DM3SAD = (u32)&pal[0];
  REG_DM3DAD = (u32)&BGPAL[0];
  REG_DM3CNT_L=128*2/4;
  REG_DM3CNT_H=(DMA_SIZE_32 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
                DMA_REPEAT_OFF | DMA_SAD_INC | DMA_DAD_INC | DMA_INTR_ON);

  while((REG_DM3CNT_H&BIT15)!=0);
  REG_DM3CNT_H = (DMA_TRANSFER_OFF);
  REG_DM3SAD = (u32)&img[0];
  REG_DM3DAD = (u32)&BGCHR2[0];
  REG_DM3CNT_L=chr*64/4;
  REG_DM3CNT_H=(DMA_SIZE_32 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
                DMA_REPEAT_OFF | DMA_SAD_INC | DMA_DAD_INC | DMA_INTR_ON);
}

void SetOAMCHR(u32 chrbase,u32 chrsize,u16* chr,u32 palbase,u32 palsize,u16* pal)
{
  funcadd(FuncC_main_img,10);
  
  if(palsize!=0){
    while((REG_DM3CNT_H&BIT15)!=0);
    REG_DM3CNT_H = (DMA_TRANSFER_OFF);
    REG_DM3SAD = (u32)&pal[0];
    REG_DM3DAD = (u32)OBJpal+(palbase*2);
    REG_DM3CNT_L=palsize*2/4;
    REG_DM3CNT_H=(DMA_SIZE_32 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
                  DMA_REPEAT_OFF | DMA_SAD_INC | DMA_DAD_INC | DMA_INTR_ON);
  }
  
  if(chrsize!=0){
    while((REG_DM3CNT_H&BIT15)!=0);
    REG_DM3CNT_H = (DMA_TRANSFER_OFF);
    REG_DM3SAD = (u32)&chr[0];
    REG_DM3DAD = (u32)OAMdata+(chrbase*64);
    REG_DM3CNT_L=chrsize*64/4;
    REG_DM3CNT_H=(DMA_SIZE_32 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
                  DMA_REPEAT_OFF | DMA_SAD_INC | DMA_DAD_INC | DMA_INTR_ON);
  }
}

void SetBG0MAP(u16 x,u16 y,u16 palno,u16 chr)
{
  funcadd(FuncC_main_img,11);
  
  BGMAP0[y*32+x]=(palno<<12)+chr;
}

void SetBG1MAP(u16 x,u16 y,u16 palno,u16 chr)
{
  funcadd(FuncC_main_img,12);
  
  BGMAP1[y*32+x]=(palno<<12)+chr;
}

void SetBG2MAP(u16 x,u16 y,u16 chr)
{
  funcadd(FuncC_main_img,13);
  
  u16 addr;
  addr=(y*64+x)>>1;
  if((x&1)==0){
    BGMAP2[addr]=(BGMAP2[addr]&0xff00)+chr;
    }else{
    BGMAP2[addr]=(BGMAP2[addr]&0x00ff)+(chr<<8);
  }
}

void SetBG2MAP16(u16 x,u16 y,u16 chr)
{
  funcadd(FuncC_main_img,14);
  
  // 16bitEAhXȂCB
  BGMAP2[(y*64+x)>>1]=chr;
}

void BG0_putpixel1(u32 x,u32 y,u16 col) // 4bitcol
{
  funcadd(FuncC_main_img,15);
  
  u32 tile;
  
  tile=((y/8)*(256/8))+(x/8);
  x=x&7;
  y=y&7;
  
  u16 *tiledata=&BGCHR0[tile*(8*8/2/2)]; // x*y/4bitpackcolor/16bitaccess
  u16 *target=&tiledata[(y*2)+(x/4)];
  
  switch (x&3){
    case 0:
      *target=(*target&0xfff0)+(((u16)col));
      break;
    case 1:
      *target=(*target&0xff0f)+(((u16)col)<<4);
      break;
    case 2:
      *target=(*target&0xf0ff)+(((u16)col)<<8);
      break;
    case 3:
      *target=(*target&0x0fff)+(((u16)col)<<12);
      break;
  }
}

void BG0_putpixel2(u32 x,u32 y,u32 col) // 4bitcol x2
{
  funcadd(FuncC_main_img,16);
  
  u32 tile;
  
  tile=((y/8)*(256/8))+(x/8);
  x=x&7;
  y=y&7;
  
  u16 *tiledata=&BGCHR0[tile*(8*8/2/2)]; // x*y/4bitpackcolor/16bitaccess
  u16 *target=&tiledata[(y*2)+(x/4)];
  
  switch (x&3){
    case 0:
      *target=(*target&0xff00)+(((u16)col));
      break;
    case 2:
      *target=(*target&0x00ff)+(((u16)col)<<8);
      break;
  }
}

void BG0_putpixel4(u32 x,u32 y,u32 col) // 4bitcol x4
{
  funcadd(FuncC_main_img,17);
  
  u32 tile;
  
  tile=((y/8)*(256/8))+(x/8);
  x=x&7;
  y=y&7;
  
  u16 *tiledata=&BGCHR0[tile*(8*8/2/2)]; // x*y/4bitpackcolor/16bitaccess
  u16 *target=&tiledata[(y*2)+(x/4)];
  
  *target=(u16)col;
}

void BG1_putpixel4(u32 x,u32 y,u32 col) // 4bitcol x4
{
  funcadd(FuncC_main_img,18);
  
  u32 tile;
  
  tile=((y/8)*(256/8))+(x/8);
  x=x&7;
  y=y&7;
  
  u16 *tiledata=&BGCHR1[tile*(8*8/2/2)]; // x*y/4bitpackcolor/16bitaccess
  u16 *target=&tiledata[(y*2)+(x/4)];
  
  *target=(u16)col;
}

