
#define OAM_DATA_SIZE 65536
#define OAM_PALETTE_SIZE 512
extern const u16 OAM_palette[];
extern const u16 OAM_data[];

u32 IconIdx;

void SetOAM(void)
{
  InitializeSprites();
  SetOAMCHR(512,(u16*)OAM_data,(u16*)OAM_palette);
  
  ChangeSprite(3,0x100);
  SetSpriteSize(3,SP_SIZE_32,SP_SQUARE,SP_COLOR_256);
  SetSpriteMode(3,SP_MODE_TRANSPERANT);
  SetSpriteRotation(3,False);
  SetSpritePriority(3,0);
  MoveSprite(3,240,160);
  
  REG_DISPCNT|=OBJ_ENABLE | OBJ_MAP_2D;
}

void IconStart(u32 x,u32 y)
{
  IconIdx=15;
  MoveSprite(3,x,y);
}

void IconNext(void)
{
  if(IconIdx==0) IconIdx=32;
  IconIdx--;
  ChangeSprite(3,0x100+((IconIdx/2%4)*8)+((IconIdx/2/4)*32*4));
}

void IconEnd(void)
{
  MoveSprite(3,240,160);
}

